'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getActionsFromLocation = require('./getActionsFromLocation');

var _getActionsFromLocation2 = _interopRequireDefault(_getActionsFromLocation);

var _getLocationFromState = require('./getLocationFromState');

var _getLocationFromState2 = _interopRequireDefault(_getLocationFromState);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (routes, history) {
  return function (createStore) {
    return function () {
      var blockPush = false;
      var store = createStore.apply(undefined, arguments);

      var storeListener = function storeListener() {
        var replace = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

        if (!blockPush) {
          var state = store.getState();
          var oldLocation = history.location;
          var newLocation = (0, _getLocationFromState2.default)(routes, oldLocation, state);

          if (!(0, _utils.locationsEqual)(oldLocation, newLocation)) {
            if (replace) {
              history.replace(newLocation);
            } else {
              history.push(newLocation);
            }
          }
        }
      };

      var historyListener = function historyListener(location) {
        var state = store.getState();
        var actions = (0, _getActionsFromLocation2.default)(routes, location, state);

        blockPush = true;
        actions.forEach(store.dispatch);
        blockPush = false;

        storeListener(true);
      };

      store.subscribe(storeListener);
      history.listen(historyListener);

      return store;
    };
  };
};