"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _values = require("babel-runtime/core-js/object/values");

var _values2 = _interopRequireDefault(_values);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getRouteFromLocation = function getRouteFromLocation(routes, location) {
  return routes.find(function (route) {
    return route.locationMatch(location);
  });
};

var redirect = function redirect(route, routes) {
  if (route && route.redirect !== undefined) {
    var redirected = routes.find(function (other) {
      return other.key === route.redirect;
    });

    return redirect(redirected, routes);
  } else {
    return route;
  }
};

var getRouteAction = function getRouteAction(route, state) {
  return route.match(state) ? null : route.action();
};

var getParamActions = function getParamActions(route, values, state) {
  return (0, _values2.default)(route.params).reduce(function (actions, param) {
    var name = param.name;
    var paramValue = values[name];
    var stateValue = param.selector(state);
    var paramValueSet = paramValue !== undefined;
    var stateValueSet = stateValue !== param.notSetValue;
    var shouldChange = paramValueSet && stateValueSet ? paramValue !== param.stringify(stateValue) : paramValueSet !== stateValueSet;

    if (param.action && shouldChange) {
      var newValue = paramValueSet ? param.parse(paramValue) : param.notSetValue;

      actions.push(param.action(newValue));
    }

    return actions;
  }, []);
};

exports.default = function (routes, location, state) {
  var locationRoute = getRouteFromLocation(routes, location);
  var route = redirect(locationRoute, routes);

  if (route !== undefined) {
    var paramValues = route.getParamValues(location);
    var routeAction = getRouteAction(route, state);
    var paramActions = getParamActions(route, paramValues, state);

    return routeAction ? [routeAction].concat((0, _toConsumableArray3.default)(paramActions)) : paramActions;
  } else {
    return [];
  }
};