'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getRouteFromState = function getRouteFromState(routes, state) {
  return routes.find(function (route) {
    return route.match(state);
  });
};

var getParamValuesFromState = function getParamValuesFromState(route, state) {
  return (0, _values2.default)(route.params).filter(function (_ref) {
    var notSetValue = _ref.notSetValue,
        selector = _ref.selector;
    return selector(state) !== notSetValue;
  }).map(function (_ref2) {
    var name = _ref2.name,
        stringify = _ref2.stringify,
        selector = _ref2.selector;
    return [name, stringify(selector(state))];
  }).reduce(_utils.createObject, {});
};

exports.default = function (routes, location, state) {
  var route = getRouteFromState(routes, state);

  if (route !== undefined) {
    var paramValues = getParamValuesFromState(route, state);
    var newLocation = route.getLocation(paramValues, location);

    return newLocation;
  } else {
    return location;
  }
};