'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.keyFilter = exports.createObject = exports.zip = exports.locationsEqual = exports.normalizeLocation = undefined;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _history = require('history');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var normalizeLocation = exports.normalizeLocation = function normalizeLocation(location) {
  return (0, _history.parsePath)((0, _history.createPath)(location));
};

var locationsEqual = exports.locationsEqual = function locationsEqual(locationA, locationB) {
  return locationA.pathname === locationB.pathname && locationA.search === locationB.search && locationA.hash === locationB.hash;
};

var zip = exports.zip = function zip(a, b) {
  var zipped = [];

  for (var index = 0; index < a.length && index < b.length; index++) {
    zipped.push([a[index], b[index]]);
  }

  return zipped;
};

var createObject = exports.createObject = function createObject(object, _ref) {
  var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
      key = _ref2[0],
      value = _ref2[1];

  object[key] = value;
  return object;
};

var keyFilter = exports.keyFilter = function keyFilter(object, condition) {
  return (0, _keys2.default)(object).filter(condition).map(function (key) {
    return [key, object[key]];
  }).reduce(createObject, {});
};